/*
Main window for Ultrasonix with some simple controls.
*/

#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <fstream.h>
#include "Mercator.h"
#include <X11/Shell.h>
#include "MainWindow.h"
#include  <X11/Xaw/Box.h>
#include  <X11/Xaw/Command.h>
#include  <stdio.h>

/* Global Mercator instance */
extern Mercator *mercator;

XtAppContext app_context;
Widget top_level=NULL;
char* fallback_resources[] = 
{
  "agent.Geometry:	                                500x600",
  "*allowShellResize: 				true",
  "*Tree*AutoReconfigure:				true",
  "*Font: -adobe-helvetica-bold-r-normal--*-120-*-*-*-*-iso*-*",
  NULL
};

void quitUltrasonix(Widget w, XtPointer merc, XtPointer call) {
  ((Mercator*)merc)->Quit();
}

void createTopLevel(int argc, char *argv[]) {
  ::top_level = XtOpenApplication(&app_context,
				  "agent",
				  NULL, 0,
				  &argc, argv,
				  fallback_resources,
				  sessionShellWidgetClass,
				  NULL,0);
}

/*
void createAgent() {
  int arg_cnt=0;
  Arg		arg_list[10];

    XtSetArg(arg_list[arg_cnt],RapAgntNautoInitiate,
	     True); arg_cnt++;
    XtSetArg(arg_list[arg_cnt], XtNbaseWidth,
	     200); arg_cnt++;
    XtSetArg(arg_list[arg_cnt], XtNbaseHeight,
	     200); arg_cnt++;

    ::rap_agnt = RapAgntCreate(::top_level, "rap_agnt",
			       arg_list,arg_cnt, RAPListener::GetProc);

#ifdef LOTS_O_PRINTFS
printf("rap_agnt = %x\n", ::rap_agnt);
#endif

    XtAddCallback(::rap_agnt,RapAgntNclientCallback,
		  (XtCallbackProc)RAPListener::ClientProc,0);
    XtAddCallback(::rap_agnt,RapAgntNobjectInfoCallback,
		  (XtCallbackProc)RAPListener::ObjectInfoProc,0);
    XtAddCallback(::rap_agnt,RapAgntNhookCallback,
		  (XtCallbackProc)RAPListener::HookProc,0);
    XtAddCallback(::rap_agnt,RapAgntNeventCallback,
		  (XtCallbackProc)RAPListener::EventProc,0);
    XtAddCallback(::rap_agnt,RapAgntNrequestCallback,
		  (XtCallbackProc)RAPListener::RequestProc,0);
}
*/

void createUI() {
  Widget command;
  int arg_cnt=0;
  Arg		arg_list[10];

  command = XtCreateManagedWidget("command",
				  commandWidgetClass, ::top_level, NULL, 0);

  arg_cnt = 0;
  XtSetArg(arg_list[arg_cnt],XtNheight,200); arg_cnt++;
  XtSetArg(arg_list[arg_cnt],XtNwidth,200); arg_cnt++;
  XtSetArg(arg_list[arg_cnt],XtNlabel,"Quit UltraSonix"); arg_cnt++;
  XtSetValues(command,arg_list, arg_cnt);
  XtAddCallback(command, XtNcallback, quitUltrasonix,
		(XtPointer)mercator);

    XtRealizeWidget(::top_level);

#ifdef LOTS_O_PRINTFS
    //  printf("ID Window = %d\n", XtWindow(XtParent(RAPListener::GetProc())));
#endif
}

