#ifdef __linux__
/*
  ok, what i am going to do is call select with all the descriptors in the
  pollfd array in each field of select() i.e. read_fds, write_fds and 
  except_fds.
  that way I cyes
an use the macros to check them and set the revents right.
*/
#include "UltraPoll.h"

int poll(pollfd *fds,unsigned long nfds, 
	 int timeout)
{
  struct timeval *tv;
  int result=0;
  fd_set reads,writes,exceptions;
  unsigned long i;

  FD_ZERO(&reads);
  FD_ZERO(&writes);
  FD_ZERO(&exceptions);
  //set up the descriptors
  for(i=0;i<nfds;i++){
    //this reads events and put them in right place
#ifdef USONIX	/* TB */
    if(fds[i].events & (POLLIN | POLLRDNORM | POLLRDBAND | POLLPRI)){
      FD_SET(fds[i].fd,&reads);
    }
    if(fds[i].events & (POLLOUT | POLLWRNORM | POLLWRBAND)){
      FD_SET(fds[i].fd,&writes);
    }
    if(fds[i].events & (POLLERR | POLLHUP | POLLNVAL)){
      FD_SET(fds[i].fd,&exceptions);
    }
#else
    if(fds[i].events== short(POLLIN | POLLRDNORM | POLLRDBAND | POLLPRI)){
      FD_SET(fds[i].fd,&reads);
    }
    if(fds[i].events== short(POLLOUT | POLLWRNORM | POLLWRBAND)){
      FD_SET(fds[i].fd,&writes);
    }
    if(fds[i].events==  short(POLLERR | POLLHUP | POLLNVAL)){
      FD_SET(fds[i].fd,&exceptions);
    }
#endif
  }

  //set up the timeval structure 
  if(timeout==INFTIM){
    tv=NULL;
  }
  else{
    tv->tv_sec=timeout;
    tv->tv_usec=0;
  }

  //actual cal to select
  result=select((int)nfds,&reads,&writes,&exceptions,tv);

  //set all the fds info properly
  //since select doesn't break things down into the nice values
  //like pol has for POLLOUT and things,
  //it just lets it work or not,
  //I will just set most ofthe relavent flags.
  //if we need more granularity, we can use errno or something later
  if(result){
    //i don't think we need to do much unless there are fds that have 
    //been active!
    for(i=0;i<nfds;i++){
       
#ifdef USONIX	/* TB */
      if(FD_ISSET(fds[i].fd,&reads)){
	fds[i].revents= POLLIN;
      }
      if(FD_ISSET(fds[i].fd,&writes)){
	fds[i].revents= POLLOUT;
      }
      if(FD_ISSET(fds[i].fd,&exceptions)){
	fds[i].revents= POLLERR;
      }
#else
      if(FD_ISSET(fds[i].fd,&reads)){
	fds[i].revents= short(POLLIN | POLLRDNORM | POLLRDBAND | POLLPRI);
      }
      if(FD_ISSET(fds[i].fd,&writes)){
	fds[i].revents= short(POLLOUT | POLLWRNORM | POLLWRBAND);
      }
      if(FD_ISSET(fds[i].fd,&exceptions)){
	fds[i].revents= short(POLLERR | POLLHUP | POLLNVAL);
      }
#endif

    }
  }

  return(result);
}

#endif
