//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
// $Log: Util.cc,v $
// Revision 0.2  1997/01/22 18:03:31  sellden
// Added nanosleep()
//
// Revision 0.1  1996/12/02 20:06:39  rcsg
// Initial Port Revision
//
//
//
//	keith edwards	6jan95
//

#include <stdio.h>
#include <string.h>
#ifdef __linux__
#include"Util.h"
#endif

char *
Strdup(const char *source)
{
    if (source == NULL)
	return NULL;
    
    char *ret = new char[strlen(source) + 1];
    strcpy(ret, source);
    
    return ret;
}

#ifdef __linux__
// nanosleep() clone using select() - see linux/sched.c for 
// more accurate version.
int nanosleep(const struct timespec *delay, struct timespec *timeLeft)
{
  timeval tv;
  tv.tv_sec = delay->tv_sec;
  tv.tv_usec = (delay->tv_nsec)/1000;

  select(0, NULL, NULL, NULL, &tv);
}
#endif
