// -*-c++-*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
// $Log: Util.h,v $
// Revision 0.2  1997/01/22 18:03:49  sellden
// Added nanosleep()
//
// Revision 0.1  1996/12/02 20:06:39  rcsg
// Initial Port Revision
//
//
//
//
//	Some handy utility routines.
//
//	keith edwards	6jan95
//

#ifndef _UTIL_H_
#define _UTIL_H_
#ifdef __linux__
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#endif

// 
// strdup(3) clone which uses the C++ memory allocator.
//
char *Strdup(const char *source);

#ifdef __linux__
// nanosleep() clone using select() - see linux/sched.c for 
// more accurate version.
int nanosleep(const struct timespec *delay, struct timespec *timeLeft);
#endif

#endif /* _UTIL_H_ */
