//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
// $Log: mRegexp.cc,v $
// Revision 0.3  1997/01/09 21:36:07  sellden
// Wrapped all changes thus far in 'ifdef USONIX'
// Removed references to copy constructor and assignment operator.
//
// Revision 0.2  1996/12/04 19:52:33  sellden
// Changed to GNU Regex
//
// Revision 0.1  1996/12/02 20:06:39  rcsg
// Initial Port Revision
//
//
//
#include "mRegexp.h"
#include "mString.h"

mRegexp::mRegexp(void) : impl("") {}
mRegexp::mRegexp(const char *pattern) : impl(pattern) {}
#ifndef USONIX
mRegexp::mRegexp(const mRegexp &r) : impl(r.impl) {}
#endif
mRegexp::~mRegexp() {}

#ifndef USONIX
mRegexp& mRegexp::operator=(const mRegexp& r) {
  impl = r.impl; return *this;
}

mRegexp& mRegexp::operator=(const char *pattern) {
  impl = pattern;
  return *this; 
}
#endif

int mRegexp::index(const mString& str, unsigned int *len, 
		   unsigned int start) const {
#ifdef USONIX
  return impl.search(str, str.length(), (int&)len, start);
#else
  return impl.index(str.impl, len, start);
#endif
}



