// This may look like C code, but it is really -*- C++ -*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
// $Log: mRegexp.h,v $
// Revision 0.3  1997/01/09 21:34:51  sellden
// Wrapped all changes thus far in 'ifdef USONIX'
// Removed references to copy constructors and assignment operator.
//
// Revision 0.2  1996/12/04 19:52:11  sellden
// Changed to GNU Regex
//
// Revision 0.1  1996/12/02 20:06:39  rcsg
// Initial Port Revision
//
//
//
#ifndef M_REGEXP_H
#define M_REGEXP_H

#ifdef USONIX
#include <Regex.h>
#else
#include <rw/regexp.h>
#endif

#include "mString.h"

class mRegexpError {
public:
  int error; // I don't use this, but I figured I'd put in in for fun.
};

class mRegexp {
private:
#ifdef USONIX
  Regex impl;
#else
RWCRegexp impl;
#endif

public:
  friend class mString;

  mRegexp(void);
  mRegexp(const char *pattern);
#ifndef USONIX
  mRegexp(const mRegexp &r);
#endif
  ~mRegexp();

#ifndef USONIX
  mRegexp& operator=(const mRegexp& r);
  mRegexp& operator=(const char *pattern);
#endif

  // This is a bit hackish.  According to the user manual, this should take
  //   mString&, int *, int, but the compiler sez it's expecting
  //   mString&, unsigned *, unsigned.  Actually, the header sez it should
  //   take mString&, size_t *, size_t, but I have no idea where site_t is
  //   declared.  If someone figures this out, they ought to change the
  //   prototype to fix this.
  int index(const mString& str, unsigned int *len,
	    unsigned int start = 0) const;
};

#endif /* MREGEXP_H */
