#ifndef RAPAGNTP_H
#define RAPAGNTP_H
/************************************************************************/
/*									*/
/*   Copyright 1996 by Digital Equipment Corporation, Maynard, Mass.	*/
/*									*/
/*                        All Rights Reserved				*/
/*								        */
/* Permission to use, copy, modify, and distribute this software and    */
/* its documentation for any purpose and without fee is hereby granted,	*/
/* provided that the above copyright notice appear in all copies and 	*/
/* that both that copyright notice and this permission notice appear in */
/* supporting documentation, and that the name Digital not be used in	*/
/* advertising or publicity pertaining to distribution of the software	*/
/* without specific, written prior permission.				*/
/*									*/
/* DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,	*/
/* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN  */
/* NO EVENT SHALL DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR	*/
/* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS	*/
/* OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, 		*/
/* NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 		*/
/* CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.		*/
/*								        */
/************************************************************************/
/*
* $Log: RapAgntP.h,v $
* Revision 0.1  1997/09/02 20:49:03  rcsg
* Initial revision
*
*/

/************************************************************************/
/*									*/
/* RapAgntP.h								*/
/*									*/
/*      Rap is a simple ICE subprotocol that uses Xt hooks to share	*/
/*	share client information with external agents.	This file	*/
/*	defines the private portions of the RapAgnt object for use	*/
/*	by agents.							*/
/*									*/
/************************************************************************/
#include <X11/CompositeP.h>
#include "RapAgnt.h"
#include "RapClnt.h"

#define RapAgntIsRapAgnt(w) \
    (XtIsSubclass(w, rapAgntObjectClass)) 

/************************************************************************/
/*									*/
/* RapAgntIceConn							*/
/*									*/
/*	A table to hold the list of known ice connections.		*/
/*									*/
/************************************************************************/
typedef struct _RapAgntIceConn 
{
    Widget			w;
    IceConn			ice_conn;
    XtInputId			input_id;
    struct _RapAgntIceConn	*next;
} RapAgntIceConn, *RapAgntIceConnPtr;

/************************************************************************/
/*									*/
/* RapAgntEventQueue							*/
/*									*/
/************************************************************************/
typedef struct _RapAgntEventQueue {
    IceConn			ice_conn;
    RapMessageHeader		header;
    char			*pdata;
    struct _RapAgntEventQueue	*next;

} RapAgntEventQueue, *RapAgntEventQueuePtr;

/************************************************************************/
/*									*/
/* RapAgnt Instance Information						*/
/*									*/
/************************************************************************/
typedef struct _RapAgntPart {
    /* Private Data
     */
    Atom		init_atom;
    int			major_opcode;
    IceListenObj	*listen_objs;
    int			num_listen_objs;
    XtInputId		*input_ids;
    char		*network_ids;
    Window		network_ids_window;
    RapAgntIceConnPtr	known_ice_conn;
    CARD16		last_sequence_num;
    Boolean		waiting_for_reply;
    CARD16		wait_sequence_num;
    CARD8		wait_opcode;
    XtPointer		reply;
    RapAgntEventQueuePtr event_queue;
    RapInfo		ri;
    
    /* Resources
     */
    XtCallbackList	client_callback;
    XtCallbackList	object_info_callback;
    XtCallbackList      hook_callback;
    XtCallbackList      event_callback;
    XtCallbackList      request_callback;
    RapAgntClientPtr	known_clients;
    Boolean		auto_initiate;
} RapAgntPart;

typedef struct _RapAgntRec {
    CorePart         	core;
    RapAgntPart		rapagnt;
} RapAgntRec, *RapAgntWidget;

/************************************************************************/
/*									*/
/* RapAgnt Class Information						*/
/*									*/
/************************************************************************/
typedef struct _RapAgntClassPart {
    XtPointer extension;
} RapAgntClassPart;

typedef struct _RapAgntClassRec {
    CoreClassPart	core_class;
    RapAgntClassPart 	rapagnt_class;
} RapAgntClassRec, *RapAgntWidgetClass;

#ifndef RAPAGNT_C
externalref RapAgntClassRec rapAgntClassRec;
#endif

#endif /* RAPAGNTP_H */
