#ifndef RAPCLNT_H
#define RAPCLNT_H
/************************************************************************/
/*									*/
/*   Copyright 1996 by Digital Equipment Corporation, Maynard, Mass.	*/
/*									*/
/*                        All Rights Reserved				*/
/*								        */
/* Permission to use, copy, modify, and distribute this software and    */
/* its documentation for any purpose and without fee is hereby granted,	*/
/* provided that the above copyright notice appear in all copies and 	*/
/* that both that copyright notice and this permission notice appear in */
/* supporting documentation, and that the name Digital not be used in	*/
/* advertising or publicity pertaining to distribution of the software	*/
/* without specific, written prior permission.				*/
/*									*/
/* DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,	*/
/* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN  */
/* NO EVENT SHALL DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR	*/
/* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS	*/
/* OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, 		*/
/* NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 		*/
/* CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.		*/
/*								        */
/************************************************************************/
/*
* $Log: RapClnt.h,v $
* Revision 0.1  1997/09/02 20:49:03  rcsg
* Initial revision
*
*/

/************************************************************************/
/*									*/
/* RapClnt.h								*/
/*									*/
/*      RAP is a simple ICE subprotocol that uses Xt hooks to share	*/
/*	share client information with external agents.	 This file	*/
/*	handles general RAP information for clients.	 		*/
/*									*/
/************************************************************************/
#define TOOLKIT	"Xt"

/* This is used so an agent can identify itself if it is RAP'ing with
 * itself.
 */
#define RAP_AGENT_SELF_CONNECT 1

/************************************************************************/
/*									*/
/* RapInfo								*/
/*									*/
/*	Holds the information for the client-side handling of RAP.	*/
/*									*/
/************************************************************************/
typedef struct _RapInfo
{
    Widget			top_level;
    CARD32			agent_window;
    IceConn			ice_conn;
    int				major_opcode;
    CARD16			hooks;			 /* hooks selected  */
    XtActionHookId		action_hook;		 /* old action hook */
    Bool			(*event_vec[128])();     /* old event procs */
    CARD32			events[4];		 /* bitset=selected */
    CARD32			requests[8];		 /* bitset=selected */
    void			(*dispatch_proc)();
    XtPointer			private;
    struct _RapInfo		*next;
} RapInfoRec, *RapInfo;

/************************************************************************/
/*									*/
/* RapObjectIDToWidget and WidgetToRapObjectID				*/
/*									*/
/*	Converts between an RapObjectID and a Widget ID.		*/
/* 									*/
/************************************************************************/
#define RapObjectIDToWidget(obj,wid) (wid) = (Widget)(obj).id 

#if defined(LONG64) || defined(WORD64)
#define WidgetToRapObjectID(wid,obj) (obj).id = (unsigned long) wid;
#else
#define WidgetToRapObjectID(wid,obj) { \
	   (obj).id = (unsigned long) wid; \
	   (obj).pad = 0; \
        }
#endif

#endif /* RAPCLNT_H */
