/************************************************************************/
/*									*/
/*   Copyright 1996 by Digital Equipment Corporation, Maynard, Mass.	*/
/*									*/
/*                        All Rights Reserved				*/
/*								        */
/* Permission to use, copy, modify, and distribute this software and    */
/* its documentation for any purpose and without fee is hereby granted,	*/
/* provided that the above copyright notice appear in all copies and 	*/
/* that both that copyright notice and this permission notice appear in */
/* supporting documentation, and that the name Digital not be used in	*/
/* advertising or publicity pertaining to distribution of the software	*/
/* without specific, written prior permission.				*/
/*									*/
/* DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,	*/
/* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN  */
/* NO EVENT SHALL DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR	*/
/* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS	*/
/* OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, 		*/
/* NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 		*/
/* CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.		*/
/*								        */
/************************************************************************/
/*
* $Log: Xtea.h,v $
* Revision 0.1  1997/09/02 19:05:02  rcsg
* Initial revision
*
*/

/************************************************************************/
/*									*/
/* Xtea.h								*/
/*									*/
/*	Header file for the Xt external agent enabling code.  This	*/
/*	file is meant to be used mainly by procotols that are used by	*/
/*	external agents (i.e., it is not meant to be included by normal	*/
/*	Xt clients.							*/
/*									*/
/************************************************************************/
/* Atoms
 */
#define ICE_PROTOCOLS			"ICE_PROTOCOLS"
#define ICE_NETWORK_IDS			"ICE_NETWORK_IDS"
#define ICE_INITIATE			"ICE_INITIATE_"
#define ICE_INITIATE_FAILED		"ICE_INITIATE_FAILED"
#define IceInitiateOpenFailed		1
#define IceInitiateAuthenticationFailed	2
#define IceInitiateSetupFailed		3
#define IceInitiateUnknownProtocol	4
#define IceInitiateRefused		5

/* The initializer functions take a widget as an argument (which they can
 * then use to retrieve an app context, display, or whatever) as well as
 * the list of ICE network ID's for the agent.	There is no return value 
 * to indicate success or failure, as there is no easy way to pass it back 
 * (XtSelectionCallbackProc has no return value).
 */
typedef void 
(*XteaProtoInitializer)(Widget,			/* Received ClientMessage */
			XClientMessageEvent *,	/* The actual message	  */
			char *,			/* ICE Network IDs	  */
			XtPointer);		/* Client data		  */

/* Function Prototypes
 */
Status 
XteaSetICEProtocols(Display *dpy, 
		    Window  w, 
		    Atom    *proto, 
		    int	    count);

Status 
XteaGetICEProtocols(Display *dpy, 
		    Window  w,
		    Atom    **prot, 
		    int	    *count);

Boolean 
XteaWillInitiate(Display *dpy,
		 Window	w,
		 Atom	prot);

Status 
XteaUpdateICE_PROTOCOLS(Display	*dpy,
			Window	w,
			Atom	prot,
			Boolean add);

Status 
XteaAddProtocol(Widget			w,
		Atom			prot, 
		XteaProtoInitializer	proc,
		XtPointer		closure);

Status 
XteaRemoveProtocol(Widget w,
		   Atom prot);

Status 
XteaSetupClient(Widget w);

Status 
XteaSetupAgent(Display	*dpy,
	       Window	w,
	       char	*ids);

Status 
XteaInitiateConnection(Display	*dpy,
		       Window	cw,
		       Window	aw,
		       Atom	prot);

Status 
XteaSendFailure(Display			*dpy,
		XClientMessageEvent	*initCme,
		Window			cw,
		unsigned int		reason);
