/*	Note:  The use of this program shall be restricted to educational,
*	non-commercial use only.  All inquiries regarding licensing this
*	software for commercial use may be addressed to:
*	
*	Georgia Tech Research Corporation
*	Technology Licensing
*	Centennial Research Building - Rm. 275
*	400 Tenth Street, N.W.
*	Atlanta, Georgia  30332-0415
*	
*	*************************************************
*	
*	       Copyright 1996
*	Georgia Tech Research Corporation
*	    All Rights Reserved
*/

/*
* $Log: main.c,v $
* Revision 0.1  1997/09/02 19:08:14  rcsg
* Initial revision
*
*/

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int
main(int argc, char **argvv)
{
  char buffer[512];
  char * hostname;
  int dectalk;
  fd_set rfds, wfds;

  hostname = getenv("DECTALKHOST");

  dectalk = open_dectalk(hostname);

  FD_ZERO(&rfds);
  FD_SET(dectalk, &rfds);
  FD_SET(0, &rfds);

  while (select(dectalk + 1, &rfds, 0, 0, NULL)) {
    if (FD_ISSET(dectalk, &rfds)) {
      int cnt;
      cnt = read(dectalk, buffer, 512);
      write(1, buffer, cnt);
      }
    if (FD_ISSET(0, &rfds)) {
      int cnt;
      cnt = read(0, buffer, 512);
      buffer[cnt] = '\0';
      if (cnt == 0) {
	hangup_phone(dectalk);
	exit(0);
	}
      
      if (buffer[0] == '&')
	switch (buffer[1]) {
	  case 'd' : dial_phone(dectalk, &buffer[2]);
		     break;
	  case 'h' : hangup_phone(dectalk, &buffer[2]);
		     break;
	  case 'r' : set_speech_rate(dectalk, atoi(&buffer[2]));
		     break;
	  case 'i' : mark_index(dectalk, atoi(&buffer[2]));
		     break;
	  case 's' : stop_speech(dectalk);
		     break;
	  case 'S' : sync_speech(dectalk);
		     break;
	  case 'p' : {
		     char * p;
		     p = strchr(&buffer[2], ' ');
		     *p++ = '\0';
		     add_to_dictionary(dectalk, &buffer[2], p);
		     break;
		     }
	  default  : fprintf(stderr, "Unkown escape\n");
	  }
      else
        speak_unix(dectalk, buffer, cnt);
      }

    FD_ZERO(&rfds);
    FD_SET(dectalk, &rfds);
    FD_SET(0, &rfds);
    }
}
