/* $XConsortium: XFreeGC.c,v 11.12 91/12/19 18:13:13 rws Exp $ */
/* Copyright    Massachusetts Institute of Technology    1986	*/

/*
Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation, and that the name of M.I.T. not be used in advertising or
publicity pertaining to distribution of the software without specific,
written prior permission.  M.I.T. makes no representations about the
suitability of this software for any purpose.  It is provided "as is"
without express or implied warranty.
*/

#include "Xlibint.h"

#ifdef GCLIST
#include "XGCList.h"
#endif GCLIST

XFreeGC (dpy, gc)
    register Display *dpy;
    GC gc;
    {
    register xResourceReq *req;
    register _XExtension *ext;

#ifdef GCLIST
    XGCListPtr myHead; 
    XGCListPtr temp, temp2;
#endif

    LockDisplay(dpy);
    ext = dpy->ext_procs;
    while (ext) {		/* call out to any extensions interested */
	if (ext->free_GC != NULL) (*ext->free_GC)(dpy, gc, &ext->codes);
	ext = ext->next;
	}    
    GetResReq (FreeGC, gc->gid, req);

#ifdef GCLIST
/* just some debugging printf stuff */
    myHead = XGCGetListHead(); 
    temp = myHead;
   {
     XGCListPtr temp2 = myHead;
     printf("about to delete:  %ld\n", gc);
     while (temp2)
    {
	printf("before GC: %ld\n", temp2->gc);
	temp2 = temp2->next;	
    }	
   }

    /* while gcids aren't necesarily unique, gcs that is ptr to GC struct,
  	is unique, right?  or should I checking for display as well? */
   if (myHead->gc == gc)
        XGCSetListHead(myHead->next);
    else
    {
      while (temp->next && temp->next->gc != gc)
         temp = temp->next;

      if (temp->next)
      {	
	temp2 = temp->next;
	temp->next = temp->next->next;
	free(temp2);
      }
      else
	{
	printf("BAD GC ERROR!\n");
	/* something is wrong this should never happen!! */
	}
    }	

/* more debug stuff */
   {
     XGCListPtr temp2 = XGCGetListHead();
     printf("about to delete:  %ld\n", gc);
     while (temp2)
    {
	printf("after GC: %ld\n", temp2->gc);
	temp2 = temp2->next;	
    }	
   }
#endif
	
	
    UnlockDisplay(dpy);
    SyncHandle();
    _XFreeExtData(gc->ext_data);
    Xfree ((char *) gc);
    }
    
